Index: branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_prep.F90
===================================================================
--- branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_prep.F90	(revision 15754)
+++ branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_prep.F90	(revision 15764)
@@ -16,4 +16,5 @@
    USE par_kind, ONLY : & ! Precision variables
       & wp   
+   USE dom_oce            ! ocean space and time domain
    USE in_out_manager     ! I/O manager
    USE obs_profiles_def   ! Definitions for storage arrays for profiles
@@ -52,6 +53,9 @@
 CONTAINS
 
-   SUBROUTINE obs_pre_surf( surfdata, surfdataqc, ld_nea, ld_bound_reject, &
-                            kqc_cutoff )
+   SUBROUTINE obs_pre_surf( surfdata, surfdataqc, & 
+      &                     kpi, kpj, &    
+      &                     zmask, pglam, pgphi, & 
+      &                     ld_nea, ld_bound_reject, & 
+      &                     ld_seaicetypes, kqc_cutoff )
       !!----------------------------------------------------------------------
       !!                    ***  ROUTINE obs_pre_sla  ***
@@ -81,6 +85,13 @@
       TYPE(obs_surf), INTENT(INOUT) :: surfdata    ! Full set of surface data
       TYPE(obs_surf), INTENT(INOUT) :: surfdataqc  ! Subset of surface data not failing screening
+      INTEGER, INTENT(IN) :: kpi, kpj              ! Local domain sizes       
+      REAL(wp), INTENT(IN), DIMENSION(kpi,kpj,surfdata%nvar) :: & 
+         & zmask       
+      REAL(wp), INTENT(IN), DIMENSION(kpi,kpj,surfdata%nvar) :: & 
+         & pglam, & 
+         & pgphi
       LOGICAL, INTENT(IN) :: ld_nea                ! Switch for rejecting observation near land
       LOGICAL, INTENT(IN) :: ld_bound_reject       ! Switch for rejecting obs near the boundary
+      LOGICAL, INTENT(IN) :: ld_seaicetypes        ! Switch to indicate sea ice data
       INTEGER, INTENT(IN), OPTIONAL :: kqc_cutoff   ! cut off for QC value
       !! * Local declarations
@@ -93,22 +104,25 @@
       INTEGER :: icycle       ! Current assimilation cycle
                               ! Counters for observations that
-      INTEGER :: iotdobs      !  - outside time domain
-      INTEGER :: iosdsobs     !  - outside space domain
-      INTEGER :: ilansobs     !  - within a model land cell
-      INTEGER :: inlasobs     !  - close to land
-      INTEGER :: igrdobs      !  - fail the grid search
-      INTEGER :: ibdysobs     !  - close to open boundary
-                              ! Global counters for observations that
-      INTEGER :: iotdobsmpp     !  - outside time domain
-      INTEGER :: iosdsobsmpp    !  - outside space domain
-      INTEGER :: ilansobsmpp    !  - within a model land cell
-      INTEGER :: inlasobsmpp    !  - close to land
-      INTEGER :: igrdobsmpp     !  - fail the grid search
-      INTEGER :: ibdysobsmpp  !  - close to open boundary
-      LOGICAL, DIMENSION(:), ALLOCATABLE :: & 
-         & llvalid            ! SLA data selection
-      INTEGER :: jobs         ! Obs. loop variable
-      INTEGER :: jstp         ! Time loop variable
-      INTEGER :: inrc         ! Time index variable
+      INTEGER                           :: iotdobs      !  - outside time domain 
+      INTEGER, DIMENSION(surfdata%nvar) :: iosdsobs     !  - outside space domain 
+      INTEGER, DIMENSION(surfdata%nvar) :: ilansobs     !  - within a model land cell 
+      INTEGER, DIMENSION(surfdata%nvar) :: inlasobs     !  - close to land 
+      INTEGER, DIMENSION(surfdata%nvar) :: ibdysobs     !  - close to open boundary 
+      INTEGER                           :: igrdobs      !  - fail the grid search       
+                                                        ! Global counters for observations that 
+      INTEGER                           :: iotdobsmpp   !  - outside time domain 
+      INTEGER, DIMENSION(surfdata%nvar) :: iosdsobsmpp  !  - outside space domain 
+      INTEGER, DIMENSION(surfdata%nvar) :: ilansobsmpp  !  - within a model land cell 
+      INTEGER, DIMENSION(surfdata%nvar) :: inlasobsmpp  !  - close to land 
+      INTEGER, DIMENSION(surfdata%nvar) :: ibdysobsmpp  !  - close to open boundary 
+      INTEGER                           :: igrdobsmpp   !  - fail the grid search 
+
+      LOGICAL, DIMENSION(:), ALLOCATABLE :: &  
+         & llvalid            ! SLA data selection 
+      INTEGER :: jobs         ! Obs. loop counter 
+      INTEGER :: jvar         ! Variable loop counter 
+      INTEGER :: jstp         ! Time loop variable 
+      INTEGER :: inrc         ! Time index variable 
+      CHARACTER(LEN=256) :: cout1  ! Diagnostic output line 
 
       IF(lwp) WRITE(numout,*)'obs_pre_surf : Preparing the surface observations...'
@@ -140,18 +154,28 @@
       ! -----------------------------------------------------------------------
 
-      CALL obs_coo_tim( icycle, &
-         &              iyea0,   imon0,   iday0,   ihou0,   imin0,      &
-         &              surfdata%nsurf,   surfdata%nyea, surfdata%nmon, &
-         &              surfdata%nday,    surfdata%nhou, surfdata%nmin, &
-         &              surfdata%nqc,     surfdata%mstp, iotdobs        )
-
-      CALL obs_mpp_sum_integer( iotdobs, iotdobsmpp )
-      
-      ! -----------------------------------------------------------------------
-      ! Check for surface data failing the grid search
-      ! -----------------------------------------------------------------------
-
-      CALL obs_coo_grd( surfdata%nsurf,   surfdata%mi, surfdata%mj, &
-         &              surfdata%nqc,     igrdobs                         )
+      IF ( ld_seaicetypes ) THEN 
+         CALL obs_coo_tim( icycle, & 
+            &              iyea0,   imon0,   iday0,   ihou0, imin0,      & 
+            &              surfdata%nsurf,   surfdata%nyea, surfdata%nmon, & 
+            &              surfdata%nday,    surfdata%nhou, surfdata%nmin, & 
+            &              surfdata%nqc,     surfdata%mstp, iotdobs,       & 
+            &              ld_seaicetypes = ld_seaicetypes ) 
+      ELSE 
+         CALL obs_coo_tim( icycle, & 
+            &              iyea0,   imon0,   iday0,   ihou0, imin0,      & 
+            &              surfdata%nsurf,   surfdata%nyea, surfdata%nmon, & 
+            &              surfdata%nday,    surfdata%nhou, surfdata%nmin, & 
+            &              surfdata%nqc,     surfdata%mstp, iotdobs        ) 
+      ENDIF 
+
+      CALL obs_mpp_sum_integer( iotdobs, iotdobsmpp ) 
+
+      ! ----------------------------------------------------------------------- 
+      ! Check for surface data failing the grid search 
+      ! ----------------------------------------------------------------------- 
+      DO jvar = 1, surfdata%nvar 
+         CALL obs_coo_grd( surfdata%nsurf, surfdata%mi(:,jvar), surfdata%mj(:,jvar), & 
+            &              surfdata%nqc,     igrdobs ) 
+      END DO 
 
       CALL obs_mpp_sum_integer( igrdobs, igrdobsmpp )
@@ -161,19 +185,20 @@
       ! -----------------------------------------------------------------------
 
-      CALL obs_coo_spc_2d( surfdata%nsurf,              &
-         &                 jpi,          jpj,          &
-         &                 surfdata%mi,   surfdata%mj,   & 
-         &                 surfdata%rlam, surfdata%rphi, &
-         &                 glamt,        gphit,        &
-         &                 tmask(:,:,1), surfdata%nqc,  &
-         &                 iosdsobs,     ilansobs,     &
-         &                 inlasobs,     ld_nea,       &
-         &                 ibdysobs,     ld_bound_reject, &
-         &                 iqc_cutoff                     )
-
-      CALL obs_mpp_sum_integer( iosdsobs, iosdsobsmpp )
-      CALL obs_mpp_sum_integer( ilansobs, ilansobsmpp )
-      CALL obs_mpp_sum_integer( inlasobs, inlasobsmpp )
-      CALL obs_mpp_sum_integer( ibdysobs, ibdysobsmpp )
+      DO jvar = 1, surfdata%nvar 
+         CALL obs_coo_spc_2d( surfdata%nsurf,                     & 
+            &                 jpi,          jpj,                  & 
+            &                 surfdata%mi(:,jvar), surfdata%mj(:,jvar), &  
+            &                 surfdata%rlam, surfdata%rphi,       & 
+            &                 pglam(:,:,jvar), pgphi(:,:,jvar),   & 
+            &                 zmask(:,:,jvar), surfdata%nqc(:),   & 
+            &                 iosdsobs(jvar), ilansobs(jvar),     & 
+            &                 inlasobs(jvar),     ld_nea,         & 
+            &                 ibdysobs(jvar), ld_bound_reject,    & 
+            &                 iqc_cutoff                     ) 
+         CALL obs_mpp_sum_integer( iosdsobs(jvar), iosdsobsmpp(jvar) ) 
+         CALL obs_mpp_sum_integer( ilansobs(jvar), ilansobsmpp(jvar) ) 
+         CALL obs_mpp_sum_integer( inlasobs(jvar), inlasobsmpp(jvar) ) 
+         CALL obs_mpp_sum_integer( ibdysobs(jvar), ibdysobsmpp(jvar) ) 
+      END DO 
 
       ! -----------------------------------------------------------------------
@@ -204,32 +229,44 @@
       ! Update the total observation counter array
       
-      IF(lwp) THEN
-         WRITE(numout,*)
-         WRITE(numout,*) ' '//surfdataqc%cvars(1)//' data outside time domain                  = ', &
-            &            iotdobsmpp
-         WRITE(numout,*) ' Remaining '//surfdataqc%cvars(1)//' data that failed grid search    = ', &
-            &            igrdobsmpp
-         WRITE(numout,*) ' Remaining '//surfdataqc%cvars(1)//' data outside space domain       = ', &
-            &            iosdsobsmpp
-         WRITE(numout,*) ' Remaining '//surfdataqc%cvars(1)//' data at land points             = ', &
-            &            ilansobsmpp
-         IF (ld_nea) THEN
-            WRITE(numout,*) ' Remaining '//surfdataqc%cvars(1)//' data near land points (removed) = ', &
-               &            inlasobsmpp
-         ELSE
-            WRITE(numout,*) ' Remaining '//surfdataqc%cvars(1)//' data near land points (kept)    = ', &
-               &            inlasobsmpp
-         ENDIF
-         WRITE(numout,*) ' Remaining '//surfdataqc%cvars(1)//' data near open boundary (removed) = ', &
-            &            ibdysobsmpp  
-         WRITE(numout,*) ' '//surfdataqc%cvars(1)//' data accepted                             = ', &
-            &            surfdataqc%nsurfmpp
-
-         WRITE(numout,*)
-         WRITE(numout,*) ' Number of observations per time step :'
-         WRITE(numout,*)
-         WRITE(numout,'(10X,A,10X,A)')'Time step',surfdataqc%cvars(1)
-         WRITE(numout,'(10X,A,5X,A)')'---------','-----------------'
-         CALL FLUSH(numout)
+      IF(lwp) THEN 
+
+         DO jvar = 1, surfdataqc%nvar        
+            IF ( jvar == 1 ) THEN 
+               cout1=TRIM(surfdataqc%cvars(1))                   
+            ELSE 
+               WRITE(cout1,'(A,A1,A)') TRIM(cout1), '/', TRIM(surfdataqc%cvars(jvar))             
+            ENDIF 
+         END DO 
+
+         WRITE(numout,*) 
+         WRITE(numout,*) ' '//TRIM(cout1)//' data outside time domain                  = ', & 
+            &            iotdobsmpp 
+         WRITE(numout,*) ' Remaining '//TRIM(cout1)//' data that failed grid search    = ', & 
+            &            igrdobsmpp 
+
+         DO jvar = 1, surfdataqc%nvar             
+            WRITE(numout,*) ' Remaining '//surfdataqc%cvars(jvar)//' data outside space domain       = ', & 
+                &            iosdsobsmpp(jvar) 
+             WRITE(numout,*) ' Remaining '//surfdataqc%cvars(jvar)//' data at land points             = ', & 
+                &            ilansobsmpp(jvar) 
+             IF (ld_nea) THEN 
+                WRITE(numout,*) ' Remaining '//surfdataqc%cvars(jvar)//' data near land points (removed) = ', & 
+                   &            inlasobsmpp(jvar) 
+             ELSE 
+                WRITE(numout,*) ' Remaining '//surfdataqc%cvars(jvar)//' data near land points (kept)    = ', & 
+                   &            inlasobsmpp(jvar) 
+             ENDIF      
+             WRITE(numout,*) ' Remaining '//surfdataqc%cvars(jvar)//' data near open boundary (removed) = ', & 
+                &            ibdysobsmpp(jvar) 
+          END DO 
+          WRITE(numout,*) ' '//TRIM(cout1)//' data accepted = ', & 
+             &            surfdataqc%nsurfmpp 
+
+         WRITE(numout,*) 
+         WRITE(numout,*) ' Number of observations per time step:' 
+         WRITE(numout,*) 
+         WRITE(numout,'(10X,A,10X,A)')'Time step',TRIM(cout1) 
+         WRITE(numout,'(10X,A,5X,A)')'---------','-----------------' 
+         CALL FLUSH(numout) 
       ENDIF
       
@@ -434,5 +471,5 @@
 
       IF ( TRIM(profdata%cvars(1)) == 'UVEL' ) THEN
-         CALL obs_uv_rej( profdata, iuvchku, iuvchkv, iqc_cutoff )
+         CALL obs_uv_rej_pro( profdata, iuvchku, iuvchkv, iqc_cutoff )
          CALL obs_mpp_sum_integer( iuvchku, iuvchkumpp )
          CALL obs_mpp_sum_integer( iuvchkv, iuvchkvmpp )
@@ -558,5 +595,5 @@
       &                    kobsno,                                        &
       &                    kobsyea, kobsmon, kobsday, kobshou, kobsmin,   &
-      &                    kobsqc,  kobsstp, kotdobs                      )
+      &                    kobsqc,  kobsstp, kotdobs, ld_seaicetypes      )
       !!----------------------------------------------------------------------
       !!                    ***  ROUTINE obs_coo_tim ***
@@ -606,4 +643,5 @@
          & kobsstp          ! Number of time steps up to the 
                             ! observation time
+      LOGICAL, OPTIONAL, INTENT(IN) :: ld_seaicetypes
 
       !! * Local declarations
@@ -620,4 +658,5 @@
       INTEGER :: iskip
       INTEGER :: idaystp
+      INTEGER :: icecount
       REAL(KIND=wp) :: zminstp
       REAL(KIND=wp) :: zhoustp
@@ -713,4 +752,17 @@
             kotdobs = kotdobs + 1
             CYCLE
+         ENDIF
+
+       ! Flag sea ice observations falling on initial timestep 
+         IF ( PRESENT(ld_seaicetypes) ) THEN 
+
+              IF ( ( kobsstp(jobs) == (nit000 - 1) ) ) THEN 
+                 IF (lwp) WRITE(numout,*)( 'Sea-ice not initialised on zeroth '// & 
+                           &    'time-step but SIT observation valid then, flagging '// & 
+                                'in time check subroutine obs_coo_tim.' ) 
+                 kobsqc(jobs) = IBSET(kobsqc(jobs),13) 
+                 kotdobs      = kotdobs + 1 
+                 CYCLE 
+              ENDIF 
          ENDIF
 
@@ -1159,8 +1211,10 @@
 #endif 
       REAL(KIND=wp), DIMENSION(2,2,kpk,kprofno) :: &
+         & zgdept, &
          & zgdepw         
       REAL(KIND=wp), DIMENSION(2,2,kprofno) :: &
          & zglam, &           ! Model longitude at grid points
-         & zgphi              ! Model latitude at grid points
+         & zgphi, &           ! Model latitude at grid points 
+         & zbathy             ! Index of deepest wet level at grid points
       INTEGER, DIMENSION(2,2,kprofno) :: &
          & igrdi, &           ! Grid i,j
@@ -1170,4 +1224,5 @@
       INTEGER :: iig, ijg           ! i,j of observation on model grid point.
       INTEGER :: jobs, jobsp, jk, ji, jj
+      REAL(KIND=wp) :: maxdepw
 
       ! Get grid point indices
@@ -1220,7 +1275,10 @@
       CALL obs_int_comm_2d( 2, 2, kprofno, kpi, kpj, igrdi, igrdj, plam, zglam )
       CALL obs_int_comm_2d( 2, 2, kprofno, kpi, kpj, igrdi, igrdj, pphi, zgphi )
+      CALL obs_int_comm_2d( 2, 2, kprofno, kpi, kpj, igrdi, igrdj, REAL(mbathy), zbathy )
       ! Need to know the bathy depth for each observation for sco
       CALL obs_int_comm_3d( 2, 2, kprofno, kpi, kpj, kpk, igrdi, igrdj, fsdepw(:,:,:), &
          &                  zgdepw )
+      CALL obs_int_comm_3d( 2, 2, kprofno, kpi, kpj, kpk, igrdi, igrdj, fsdept(:,:,:), & 
+         &                  zgdept )
 
       DO jobs = 1, kprofno
@@ -1258,4 +1316,14 @@
          DO jobsp = kpstart(jobs), kpend(jobs)
 
+            ! Calculate max T and W depths of 2x2 grid 
+            maxdepw=zgdepw(1,1,NINT(zbathy(1,1,jobs))+1,jobs) 
+            DO jj = 1, 2 
+               DO ji = 1, 2 
+                  IF ( zgdepw(ji,jj,NINT(zbathy(ji,jj,jobs))+1,jobs) > maxdepw ) THEN 
+                     maxdepw = zgdepw(ji,jj,NINT(zbathy(ji,jj,jobs))+1,jobs) 
+                  END IF 
+               END DO 
+            END DO
+
             ! Flag if the observation falls outside the model spatial domain
             IF (       ( pobslam(jobs) < -180.         )       &
@@ -1264,5 +1332,5 @@
                &  .OR. ( pobsphi(jobs) >   90.         )       &
                &  .OR. ( pobsdep(jobsp) < 0.0          )       &
-               &  .OR. ( pobsdep(jobsp) > gdepw_1d(kpk)) ) THEN
+               &  .OR. ( pobsdep(jobsp) >= maxdepw ) ) THEN
                kobsqc(jobsp) = IBSET(kobsqc(jobsp),11)
                kosdobs = kosdobs + 1
@@ -1327,9 +1395,4 @@
             ENDIF
             
-            ! Set observation depth equal to that of the first model depth
-            IF ( pobsdep(jobsp) <= pdep(1) ) THEN
-               pobsdep(jobsp) = pdep(1)  
-            ENDIF
-            
 #if defined key_bdy
             ! Flag if the observation falls close to the boundary rim
@@ -1405,7 +1468,7 @@
    END SUBROUTINE obs_pro_rej
 
-   SUBROUTINE obs_uv_rej( profdata, knumu, knumv, kqc_cutoff )
-      !!----------------------------------------------------------------------
-      !!                    ***  ROUTINE obs_uv_rej ***
+   SUBROUTINE obs_uv_rej_pro( profdata, knumu, knumv, kqc_cutoff )
+      !!----------------------------------------------------------------------
+      !!                    ***  ROUTINE obs_uv_rej_pro ***
       !!
       !! ** Purpose : Reject u if v is rejected and vice versa
@@ -1439,5 +1502,5 @@
             & ( profdata%npvend(jprof,1) /= profdata%npvend(jprof,2) ) ) THEN
 
-            CALL ctl_stop('U,V profiles inconsistent in obs_uv_rej')
+            CALL ctl_stop('U,V profiles inconsistent in obs_uv_rej_pro')
             RETURN
 
@@ -1461,5 +1524,5 @@
       END DO
 
-   END SUBROUTINE obs_uv_rej
+   END SUBROUTINE obs_uv_rej_pro
 
 END MODULE obs_prep
Index: branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_profiles_def.F90
===================================================================
--- branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_profiles_def.F90	(revision 15754)
+++ branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_profiles_def.F90	(revision 15764)
@@ -72,5 +72,6 @@
          & vdep,  &       !: Depth coordinate of profile data
          & vobs,  &       !: Profile data
-         & vmod           !: Model counterpart of the profile data vector
+         & vmod,  &       !: Model counterpart of the profile data vector 
+         & vclm           !: Climatological counterpart of the profile data vector
 
       REAL(KIND=wp), POINTER, DIMENSION(:,:) :: &
@@ -101,4 +102,6 @@
       INTEGER :: npk
       INTEGER :: nprofup  !: Observation counter used in obs_oper
+
+      LOGICAL :: lclim    !: Climatology will be calculated for this structure
 
       ! Bookkeeping arrays with sizes equal to number of variables
@@ -198,5 +201,5 @@
    
    SUBROUTINE obs_prof_alloc( prof,  kvar, kext, kprof,  &
-      &                       ko3dt, kstp, kpi, kpj, kpk )
+      &                       ko3dt, kstp, kpi, kpj, kpk, ldclim )
       !!----------------------------------------------------------------------
       !!                     ***  ROUTINE obs_prof_alloc  ***
@@ -221,4 +224,5 @@
       INTEGER, INTENT(IN) :: kpj
       INTEGER, INTENT(IN) :: kpk
+      LOGICAL, INTENT(IN) :: ldclim
 
       !!* Local variables
@@ -236,4 +240,6 @@
       prof%npj       = kpj
       prof%npk       = kpk
+
+      prof%lclim     = ldclim
 
       ! Allocate arrays of size number of variables
@@ -503,4 +509,9 @@
             & )
       ENDIF
+      IF (prof%lclim) THEN 
+         ALLOCATE( &  
+            & prof%var(kvar)%vclm(kobs) & 
+            & ) 
+      ENDIF
 
    END SUBROUTINE obs_prof_alloc_var
@@ -537,4 +548,9 @@
          DEALLOCATE( & 
             & prof%var(kvar)%vext  &
+            & ) 
+      ENDIF 
+      IF (prof%lclim) THEN 
+         DEALLOCATE( &  
+            & prof%var(kvar)%vclm  &
             & )
       ENDIF
@@ -630,5 +646,6 @@
             &                 inprof,    invpro,    &
             &                 prof%nstp, prof%npi,  &
-            &                 prof%npj,  prof%npk )
+            &                 prof%npj,  prof%npk,  & 
+            &                 prof%lclim )
       ENDIF
 
@@ -745,4 +762,8 @@
                            &                      prof%var(jvar)%vext(jj,jext)
                      END DO
+                     IF (newprof%lclim) THEN 
+                        newprof%var(jvar)%vclm(invpro(jvar))   = & 
+                           &                           prof%var(jvar)%vclm(jj) 
+                     ENDIF
                   
                      ! nvind is the index of the original variable data
@@ -870,4 +891,7 @@
                      &                        prof%var(jvar)%vext(jj,jext)
                END DO
+               IF (prof%lclim) THEN 
+                  oldprof%var(jvar)%vclm(jl)   = prof%var(jvar)%vclm(jj) 
+               ENDIF
                
             END DO
Index: branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_prof.F90
===================================================================
--- branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_prof.F90	(revision 15754)
+++ branches/UKMO/r6232_obs_oper_update/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_prof.F90	(revision 15764)
@@ -46,5 +46,5 @@
       &                     kvars, kextr, kstp, ddobsini, ddobsend, &
       &                     ldvar, ldignmis, ldsatt, &
-      &                     ldmod, kdailyavtypes )
+      &                     ldmod, ldclim, cdvars, kdailyavtypes )
       !!---------------------------------------------------------------------
       !!
@@ -78,6 +78,8 @@
       LOGICAL, INTENT(IN) :: ldsatt     ! Compute salinity at all temperature points
       LOGICAL, INTENT(IN) :: ldmod      ! Initialize model from input data
+      LOGICAL, INTENT(IN) :: ldclim     ! Set flag to show climatology will be output
       REAL(dp), INTENT(IN) :: ddobsini  ! Obs. ini time in YYYYMMDD.HHMMSS
       REAL(dp), INTENT(IN) :: ddobsend  ! Obs. end time in YYYYMMDD.HHMMSS
+      CHARACTER(len=8), DIMENSION(kvars), INTENT(IN) :: cdvars
       INTEGER, DIMENSION(imaxavtypes), OPTIONAL :: &
          & kdailyavtypes                ! Types of daily average observations
@@ -86,5 +88,5 @@
       CHARACTER(LEN=15), PARAMETER :: cpname='obs_rea_prof'
       CHARACTER(len=8) :: clrefdate
-      CHARACTER(len=8), DIMENSION(:), ALLOCATABLE :: clvars
+      CHARACTER(len=8), DIMENSION(:), ALLOCATABLE :: clvarsin
       INTEGER :: jvar
       INTEGER :: ji
@@ -220,16 +222,20 @@
             ENDIF
 
-            IF ( jj == 1 ) THEN
-               ALLOCATE( clvars( inpfiles(jj)%nvar ) )
-               DO ji = 1, inpfiles(jj)%nvar
-                 clvars(ji) = inpfiles(jj)%cname(ji)
-               END DO
+            IF ( jj == 1 ) THEN 
+               ALLOCATE( clvarsin( inpfiles(jj)%nvar ) ) 
+               DO ji = 1, inpfiles(jj)%nvar 
+                 clvarsin(ji) = inpfiles(jj)%cname(ji) 
+                 IF ( clvarsin(ji) /= cdvars(ji) ) THEN 
+                    CALL ctl_stop( 'Feedback file variables do not match', & 
+                        &           ' expected variable names for this type' ) 
+                 ENDIF 
+               END DO 
             ELSE
-               DO ji = 1, inpfiles(jj)%nvar
-                  IF ( inpfiles(jj)%cname(ji) /= clvars(ji) ) THEN
-                     CALL ctl_stop( 'Feedback file variables not consistent', &
-                        &           ' with previous files for this type' )
-                  ENDIF
-               END DO
+               DO ji = 1, inpfiles(jj)%nvar 
+                  IF ( inpfiles(jj)%cname(ji) /= clvarsin(ji) ) THEN 
+                     CALL ctl_stop( 'Feedback file variables not consistent', & 
+                        &           ' with previous files for this type' ) 
+                  ENDIF 
+               END DO 
             ENDIF
 
@@ -500,5 +506,5 @@
       ENDIF
       CALL obs_prof_alloc( profdata, kvars, kextr, iprof, iv3dt, &
-         &                 kstp, jpi, jpj, jpk )
+         &                 kstp, jpi, jpj, jpk, ldclim )
 
       ! * Read obs/positions, QC, all variable and assign to profdata
@@ -506,5 +512,5 @@
       profdata%nprof     = 0
       profdata%nvprot(:) = 0
-      profdata%cvars(:)  = clvars(:)
+      profdata%cvars(:)  = clvarsin(:)
       iprof = 0
 
@@ -696,4 +702,7 @@
                               profdata%var(jvar)%vmod(ivart(jvar)) = &
                                  &                inpfiles(jj)%padd(ij,ji,1,jvar)
+                           ENDIF
+                           IF ( profdata%lclim ) THEN 
+                              profdata%var(jvar)%vclm(ivart(jvar)) = fbrmdi 
                            ENDIF
                            ! Count number of profile var1 data as function of type
@@ -805,5 +814,5 @@
       ! Deallocate temporary data
       !-----------------------------------------------------------------------
-      DEALLOCATE( ifileidx, iprofidx, zdat, clvars )
+      DEALLOCATE( ifileidx, iprofidx, zdat, clvarsin )
 
       !-----------------------------------------------------------------------
